//Fortran: EQUIVALENCE ( ... )
Unit ASP5Z_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

procedure ASP5Z(var A :Array of Complex; var B :Array of Complex;
                var X :Array of Complex; N :Integer; M :Integer;
                Z :Integer);

implementation

procedure ASP5Z(var A :Array of Complex; var B :Array of Complex;
                var X :Array of Complex; N :Integer; M :Integer;
                Z :Integer);
var
I,J,K,L :Integer;
V1,V2,W1,W2,R,A1,A2,E :Real;
D,DD,D1,D2 :Extended;
S1,R1,R2,P,T,C,S :Complex;
V :Array [0..1] of Real;
W :Array [0..1] of Real;
label
_1,_2,_3,_4,_5,_6,_7,_8,_9,_10,_11,_12,_13,_14,_15;
begin
for I:=1 to N do
 begin
_1:
  X[I-1] := B[I-1];
 end;
if ( Z <> 1 )
 then goto _8;
for K:=1 to N do
 begin
  L := K+1;
  if ( L > M )
   then goto _7;
  for J:=L to M do
   begin
    R2 := A[(K-1)+(J-1)*N];
    A2 := Cabs(R2);
    if ( A2 = 0.0 )
     then goto _6;
    R1 := A[(K-1)+(K-1)*N];
    A1 := Cabs(R1);
    if ( A1 <> 0.0 )
     then goto _2;
    T := Cmplx(1.0,0.0);
    A[(K-1)+(K-1)*N] := A[(K-1)+(J-1)*N];
    goto _4;
_2:
    if ( A1 <= A2 )
     then goto _3;
    P := DivC(R2,R1);
    E := A2/A1;
    R := Sqrt(1.0+E*E);
    T := DivC(P,Cmplx(R+1.0,0.0));
    T := Conjg(T);
    A[(K-1)+(K-1)*N] := MulC(Conjg(DivC(Cmplx(A1,0.0),R1)),Cmplx(A1*R,0.0));
    goto _4;
_3:
    P := DivC(R1,R2);
    E := A1/A2;
    R := Sqrt(1.0+E*E);
    C := DivC(Cmplx(A1,0.0),R1);
    V[0] := C.re;
    V[1] := C.im;
    V1 := V[0];
    V2 := V[1];
    S := DivC(Cmplx(A2,0.0),R2);
    W[0] := S.re;
    W[1] := S.im;
    W1 := W[0];
    W2 := W[1];
    T := DivC(C,MulC(S,Cmplx(R+E,0.0)));
    T := Conjg(T);
    A[(K-1)+(K-1)*N] := MulC(Conjg(C),Cmplx(A2*R,0.0));
_4:
    A[(K-1)+(J-1)*N] := T;
    E := Cabs(T);
    R := E*E;
    A1 := 1.0/(1.0+R);
    C := Cmplx((1.0-R)*A1,0.0);
    V[0] := C.re;
    V[1] := C.im;
    V1 := V[0];
    V2 := V[1];
    S := MulC((AddC(T,T)),Cmplx(A1,0.0));
    W[0] := S.re;
    W[1] := S.im;
    W1 := W[0];
    W2 := W[1];
    S1 := Conjg(S);
    if ( L > N )
     then goto _6;
    for I:=L to N do
     begin
      R1 := A[(I-1)+(K-1)*N];
      R2 := A[(I-1)+(J-1)*N];
      A[(I-1)+(K-1)*N] := AddC(MulC(R1,C),MulC(R2,S));
      A[(I-1)+(J-1)*N] := SubC(MulC(R2,C),MulC(R1,S1));
_5:
     end;
_6:
   end;
_7:
 end;
_8:
X[0] := DivC(X[0],A[0+0*N]);
if ( N = 1 )
 then goto _11;
for K:=2 to N do
 begin
  L := K-1;
  D := 0.0;
  DD := 0.0;
  for J:=1 to L do
   begin
    C := A[(K-1)+(J-1)*N];
    V[0] := C.re;
    V[1] := C.im;
    V1 := V[0];
    V2 := V[1];
    S := X[J-1];
    W[0] := S.re;
    W[1] := S.im;
    W1 := W[0];
    W2 := W[1];
    D1 := V1;
    D2 := V2;
    D := D+(D1*W1-D2*W2);
_9:
    DD := DD+(D2*W1+D1*W2);
   end;
  C := X[K-1];
  V[0] := C.re;
  V[1] := C.im;
  V1 := V[0];
  V2 := V[1];
  D1 := V1;
  D2 := V2;
  D := D1-D;
  DD := D2-DD;
  V1 := D;
  V[0] := V1;
  V2 := DD;
  V[1] := V2;
  C := Cmplx(V[0],V[1]);
_10:
  X[K-1] := DivC(C,A[(K-1)+(K-1)*N]);
 end;
_11:
K := N;
if ( N = M )
 then goto _15;
J := N+1;
for I:=J to M do
 begin
_12:
  X[I-1] := Cmplx(0.0,0.0);
 end;
_13:
J := M;
_14:
T := A[(K-1)+(J-1)*N];
R := Creal(MulC(T,T));
R1 := Cmplx(1.0/(1.0+R),0.0);
C := MulC(Cmplx((1.0-R),0.0),R1);
V[0] := C.re;
V[1] := C.im;
V1 := V[0];
V2 := V[1];
S := MulC((AddC(T,T)),R1);
W[0] := S.re;
W[1] := S.im;
W1 := W[0];
W2 := W[1];
S1 := Conjg(S);
R1 := X[K-1];
R2 := X[J-1];
X[K-1] := SubC(MulC(C,R1),MulC(S1,R2));
X[J-1] := AddC(MulC(S,R1),MulC(C,R2));
J := J-1;
if ( J > K )
 then goto _14;
_15:
K := K-1;
if ( K > 0 )
 then goto _13;
end;

end.
